/* DAEMON.H     General Daemon Server definitions
 *
 * Copyright (C) 1994-1995 ITB CompuPhase
 * All rights reserved.
 */
#ifndef __DAEMON_H
#define __DAEMON_H

/* To avoid compiler dependency, we define our own registers structures. Use
 * this structure instead of the REGS structure of Microsoft C and Borland C
 * compilers.
 */
union D_REGS {
  struct {
    unsigned short ax,bx,cx,dx,si,di,flags,es,ds;
  } x;
  struct {
    unsigned char al,ah,bl,bh,cl,ch,dl,dh;
  } h;
};

/*
 * Definitions for the link table.
 */
typedef int (_far *D_EXPORTED)();
typedef struct {
  char _far *name;
  D_EXPORTED func;
} _far D_TABLE[], _far *D_TABLEPTR;

/*
 * General constants
 */
#define D_MEM_FIRSTFIT  0x00
#define D_MEM_LASTFIT   0x02
#define D_MEM_UMB       0x80

#define D_SYSREQ_INIT   0xf0
#define D_SYSREQ_EXIT   0xf1
#define D_SYSREQ_ADDR   0xf2
#define D_SYSREQ_VER    0xf4

/*
 * Useful macros
 */
#define D_EXPORT      _far _loadds

#if !defined(MAKELONG)
#  define MAKELONG(l,h) ((unsigned short)(l) | ((long)(unsigned short)(h) << 16))
#endif
#if !defined(MK_FP)
#  define MK_FP(s,o)  (void _far *)(((unsigned long)(s) << 16) | (unsigned short)(o))
#endif
#if !defined(FP_SEG)
#  define FP_SEG(p)   ((unsigned short)((unsigned long)(void _far *)(p) >> 16))
#  define FP_OFF(p)   ((unsigned short)(unsigned long)(void _far *)(p))
#endif

/* DLIB.ASM
 * General function to call the Daemon server
 */
short _far d_call(union D_REGS _far *lpRegs);
short _far d_init(void);
short _far d_inload(void);
short _far d_getnumber(char _far *filename);
short _far d_load(char _far *filename, short options);
short _far d_link(short daemon_number, void (_far _interrupt *callback)());
short _far d_linkall(short daemon_number, D_TABLEPTR table);
void  _far * _far d_procaddr(short daemon_number, char _far *procname);
void  _far d_unlinkall(D_TABLEPTR table);
short _far d_unload(short daemon_number);
short _far d_version(short daemon_number);

/* CALLBACK.C
 * Prototype for the "glue" function.
 */
void _interrupt _far d_callback();

#endif
